package ru.amse.kiselev.fsmeditor.automaton;

public class Alphabet implements IAlphabet {
	public class Symbol implements ISymbol {
		private int myIndex;

		private Symbol(int c) {
			myIndex = c;
		}

		public int getIndex() {
			return myIndex;
		}
	}

	public static final Alphabet INSTANCE = new Alphabet(128);
	private ISymbol[] myAlphabet;
	private String[] myStrings;

	private Alphabet(int size) {
		myAlphabet = new Symbol[size];
		myStrings = new String[size];
		for (int i = 0; i < size; i++) {
			myAlphabet[i] = new Symbol(i);
			myStrings[i] = (char) (i) + "";
		}
	}

	public int getSize() {
		return myAlphabet.length;
	}

	public ISymbol getSymbol(int index) {
		if (index < 0 || index >= myAlphabet.length) {
			throw new IllegalArgumentException("Symbol out of bounds!\n");
		} else {
			if (myAlphabet[index] == null) {
				throw new RuntimeException("Bad work\n");
			}
			return myAlphabet[index];
		}
	}

	public ISymbol getSymbol(String s) {
		int index = getNum(s);
		if (index < 0 || index >= myAlphabet.length) {
			return null;
		} else {
			if (myAlphabet[index] == null) {
				throw new RuntimeException("Bad work\n");
			}
			return myAlphabet[index];
		}
	}

	public String getString(int index) {
		if (index < 0 || index >= myAlphabet.length) {
			throw new IllegalArgumentException("Symbol out of bounds!\n");
		} else {
			return myStrings[index];
		}
	}

	public int getNum(String symbol) {
		for (int i = 0; i < myStrings.length; i++) {
			if (myStrings[i].equals(symbol)) {
				return i;
			}
		}
		return -1;
	}

	public String getString(ISymbol symbol) {
		if (symbol.getIndex() < 0 || symbol.getIndex() >= getSize()) {
			throw new IllegalArgumentException("Symbol out of bounds!\n");
		}
		return myStrings[symbol.getIndex()];
	}

}
