package ru.amse.kiselev.fsmeditor.automaton;

public class AutomatonFactory<A extends IAlphabet> {
	private A myAlphabet;
//	private IAutomaton<A> myAutomaton;
	
	public AutomatonFactory(A alphabet) {
		myAlphabet = alphabet;
	//	myAutomaton = automaton;
	}
	
	public IState<A> createState(String label){
		return new State<A>(myAlphabet, label);
	}
	
	public ICondition<A> createCondition(String condition) {
		return new Condition<A>(myAlphabet.getSymbol(myAlphabet.getNum(condition)));
	}

	public ICondition<A> createCondition(int index) {
		return new Condition<A>(myAlphabet.getSymbol(index));
	}
	
	public ITransition<A> createTransition(IState<A> start, IState<A> end, ICondition<A> condition) {
		return new Transition<A>(start, end, condition);
	}
	
	public A getAlphabet(){
		return myAlphabet;
	}
}
