package ru.amse.kiselev.fsmeditor.automaton;

import java.util.Collection;

public interface IAutomaton<A extends IAlphabet> {

	public void setInitialState(IState<A> s);

	public IState<A> getInitialState();

	public void addState(IState<A> state);

	public void removeState(IState<A> state);

	public void addTransition(ITransition<A> transition);

	public void removeTransition(ITransition<A> transition);

	public Collection<IState<A>> getStates();
	
	public void removeAllStates();
}
