package ru.amse.kiselev.fsmeditor.automaton;

import java.util.Collection;

public interface IState<A extends IAlphabet> {
	public Collection<ITransition<A>> getTransitions();

	public ITransition<A> getTransition(ISymbol symbol);

	public IState<A> getNextState(ISymbol symbol);

	public void addTransition(ITransition<A> transition);

	public String getLabel();

	public void setLabel(String label);

	public void setFinal();

	public void setNonFinal();

	public boolean isFinal();

	public void removeTransition(ITransition<A> transition);

	/**
	 * @param state
	 * @return null if {@code this IState} doesn't connect with state,
	 *         connection {@code ITransition} otherwise
	 */
	public Collection<ITransition<A>> connectedWith(IState<A> state);
}
