package ru.amse.kiselev.fsmeditor.automaton;

//Unmodifiable

public class Transition<A extends IAlphabet> implements ITransition<A> {
	private final IState<A> myStart;
	private final IState<A> myEnd;
	private final ICondition<A> myCondition;

	public Transition(IState<A> start, IState<A> end, ICondition<A> condition) {
				myStart = start;
				myEnd = end;
				myCondition = condition;
	}
	
	public ICondition<A> getCondition() {
		return myCondition;
	}

	public IState<A> getEnd() {
		return myEnd;
	}

	public IState<A> getStart() {
		return myStart;
	}
}
