package ru.amse.kiselev.fsmeditor.graphics.representation;

import java.util.Collection;

import ru.amse.kiselev.fsmeditor.automaton.IAlphabet;
import ru.amse.kiselev.fsmeditor.automaton.IAutomaton;
import ru.amse.kiselev.fsmeditor.automaton.IState;

public interface IGraphicalRepresentation<A extends IAlphabet> {
	// HashMap: Vertex -> x, y coordinates(Point)


	public Collection<IVertex<A>> getVertexes();

	public boolean addVertex(IVertex<A> v);
	
	public IVertex<A> getVertex(IState<A> state);

	public boolean removeVertex(IVertex<A> v);
	
	public void removeAllVertexes();
	
	public void addAll(IAutomaton<A> automaton);
	
	public IAutomaton<A> getAutomaton();
}
