package ru.amse.kiselev.fsmeditor.graphics.representation;

import java.awt.geom.Point2D;

import ru.amse.kiselev.fsmeditor.automaton.IAlphabet;
import ru.amse.kiselev.fsmeditor.automaton.IState;

public interface IVertex<A extends IAlphabet> {
	public final static int DEFAULT_RADIUS = 20;

	public int getX();

	public int getY();

	public IState<A> getState();

	public void setLocation(Point2D p);

	public void setLocation(int x, int y);

	public int getRadius();

	public double distance(Point2D p);

	public double distance(int x, int y);

	public String getString();
}
