package ru.amse.kiselev.fsmeditor.interpreter;

import java.util.Collection;
import java.util.List;

import ru.amse.kiselev.fsmeditor.automaton.IAlphabet;
import ru.amse.kiselev.fsmeditor.automaton.IAutomaton;
import ru.amse.kiselev.fsmeditor.automaton.IState;
import ru.amse.kiselev.fsmeditor.automaton.ISymbol;

public interface IInterpreter<A extends IAlphabet> {
	public int step();

	public void reset();

	public boolean isAccepted();

	public IState<A> getCurrentState();

	public int getCurrentOffset();

	public IAutomaton<A> getAutomaton();

	public Collection<ISymbol> getCommands();

	public void reset(List<ISymbol> newString);

}
